this.name        = "behemoth"; 
this.author      = "Aegidian"; 
this.copyright   = "2008 - 2014 the Oolite team."; 
this.description = "Addition script of the Behemoth carrier in Witchspace."; 
this.version     = "3.0"; 

//3.0 moar behemoths and update to Oolite 1.79 -spara-

this.behemoth  = ["behemoth-ymir", "behemoth-argus", "behemoth-atlas", "behemoth-grid", "behemoth-surt", "behemoth-talos", "behemoth-tethys", "behemoth-bolverk", "behemoth-gog", "behemoth-magog", "behemoth-titan", "behemoth-loki", "behemoth-goliath", "behemoth-colossus", "behemoth-nimrod", "behemoth-geryon","behemoth-akdamut", "behemoth-aphrodite", "behemoth-athena", "behemoth-demeter", "behemoth-dionysus", "behemoth-hera", "behemoth-hestia", "behemoth-oceanus", "behemoth-olympic", "behemoth-phoebe", "behemoth-poseidon", "behemoth-prometheus", "behemoth-ramesses-ii", "behemoth-tarasque", "behemoth-titanic","behemoth-zeus","behemoth-antiphates", "behemoth-damasen", "behemoth-elatreus", "behemoth-geryones", "behemoth-mylinos", "behemoth-orion", "behemoth-steropes", "behemoth-typhoeus"];

this.behemothList = this.behemoth.concat();

this.systemWillPopulate = function() {
	// don't add police ships in anarchies.
	if(Math.random() < 0.015 * system.government)
		system.setPopulator("behemoth", {
			callback: function(pos) {
				system.addShips(this.uniqueBehemoth(),1,pos);
			}.bind(this),
			location: "LANE_WP"
		});
}


this.interstellarSpaceWillPopulate = function() {
	//(0 to 3 ships with distribution towards 0)
	var number = Math.floor(Math.random()*Math.random()*4.5);
	system.setPopulator("behemoth", {
		callback: function(pos) {
			//spread 'em up a bit
			system.addShips(this.uniqueBehemoth(),1,pos.add(Vector3D.randomDirection(25000)));
		}.bind(this),
		groupCount: number
	});
}

this.uniqueBehemoth = function()
{
    if(this.behemothList.length === 0) this.behemothList = this.behemoth.concat(); // reset the list
    return this.behemothList.splice(Math.floor(Math.random()*this.behemothList.length), 1);
    // Make sure that every time a ship with new name is pulled of the list.
}

this.addBehemoth = function (role) 
{
    this.behemoth.push(role);
    this.behemothList.push(role);
}

/*
You can check from an other JS script if behemoth.oxp is installed with: if(worldScripts.behemoth)
Or you can get any of the behemoth names with: worldScripts.behemoth.behemoth[i]
Or an unique behemoth role with: worldScripts.behemoth.uniqueBehemoth()
this.uniqueBehemoth() is added in versio 2.5. and should stay in in future.
*/
